본문으로 건너뛰기

Quick Start with React Scheduler

노트

This tutorial covers the React wrapper included in the Commercial, Enterprise, and Ultimate editions of DHTMLX Scheduler. If you are using the Individual or GPL edition, follow the alternative guide: How to Start with React.

The React Scheduler component is the official wrapper for DHTMLX Scheduler. This guide walks you through creating a small React application and rendering a basic Scheduler using the trial package.

If you're new to React, start with the official React documentation. Check a complete working project that follows this tutorial on GitHub.

Version requirements

  • React 18 or newer

Creating a new React project

To create a React project and go to the project directory, run the following commands:

npm create vite@latest react-scheduler-quick-start -- --template react-ts
cd react-scheduler-quick-start

Installing React Scheduler

Install React Scheduler as described in the React Scheduler installation guide.

In this tutorial we use the evaluation package:

npm install @dhtmlx/trial-react-scheduler

or

yarn add @dhtmlx/trial-react-scheduler

If you already use the Professional package, replace @dhtmlx/trial-react-scheduler with @dhx/react-scheduler in the commands and imports.

Adding demo data

We'll use static data for this example. Create a file named src/demoData.ts:

import type { Event } from '@dhtmlx/trial-react-scheduler';

export const events: Event[] = [
{
id: 1,
classname: 'blue',
start_date: new Date('2025-12-08T02:00:00Z'),
end_date: new Date('2025-12-08T10:20:00Z'),
text: 'Product Strategy Hike',
},
{
id: 2,
classname: 'blue',
start_date: new Date('2025-12-08T12:00:00Z'),
end_date: new Date('2025-12-08T16:00:00Z'),
text: 'Agile Meditation and Release',
},
{
id: 3,
classname: 'violet',
start_date: new Date('2025-12-09T06:00:00Z'),
end_date: new Date('2025-12-09T11:00:00Z'),
text: 'Tranquil Tea Time',
},
// ....
];

Creating a Scheduler component

To add a Scheduler component, create an src/components/Scheduler/Scheduler.tsx file with the following content:

import { useMemo, useRef } from 'react';
import ReactScheduler, {
type ReactSchedulerRef,
type Event,
type SchedulerTemplates,
type SchedulerConfig,
} from '@dhtmlx/trial-react-scheduler';
import '@dhtmlx/trial-react-scheduler/dist/react-scheduler.css';
import './styles.css';

export interface ReactSchedulerProps {
events: Event[];
activeView?: string;
activeDate?: Date;
}

export default function Scheduler({
events,
activeView = 'week',
activeDate = new Date('2025-12-08T00:00:00Z'),
}: ReactSchedulerProps) {
const schedulerRef = useRef<ReactSchedulerRef>(null);

const templates: SchedulerTemplates = useMemo(
() => ({
event_class: (start: Date, end: Date, event: Event) => {
return event.classname || '';
},
}),
[]
);

const config: SchedulerConfig = useMemo(() => {
return {
first_hour: 6,
last_hour: 22,
hour_size_px: 60,
};
}, []);

return (
<ReactScheduler
ref={schedulerRef}
events={events}
view={activeView}
date={activeDate}
templates={templates}
config={config}
data={{
save: (entity: string, action: string, data: Event, id: string | number) => {
console.log(`${entity} - ${action} - ${id}`, data);
},
}}
/>
);
}

Finally, the CSS classes (.violet, .green, .yellow) are applied through the event_class template to customize the visual appearance of the events:

.violet {
--dhx-scheduler-event-background: linear-gradient(180deg, #d071ef 0%, #ee71d5 100%);
}
.green {
--dhx-scheduler-event-background: linear-gradient(180deg, #12d979 0%, #1ecdeb 100%);
}
.yellow {
--dhx-scheduler-event-background: linear-gradient(180deg, #ffb725 0%, #ffbb25 31.25%, #faea27 100%);
}

Rendering Scheduler in the App

To display Scheduler, replace the code of src/App.tsx with the following one:

import './App.css';
import Scheduler from './components/Scheduler/Scheduler';
import { events } from './demoData';

function App() {
return (
<div style={{ width: '100vw', height: '100vh' }}>
<Scheduler events={events} />
</div>
);
}

export default App;

After that, run the app using the command below:

npm run dev

At this point, you have a fully working React + DHTMLX Scheduler application.

This setup represents the minimum configuration needed to:

  • render a Scheduler
  • display events
  • apply a basic scale configuration
  • attach the Scheduler instance via a React ref
  • receive events through the data.save callback

This is the same minimal example used in the GitHub demo project.

From here, you can continue by adding more advanced features:

  • syncing data with React state
  • loading/saving data from your backend
  • adding templates and custom renderers
  • adding filtering
  • replacing the Lightbox with a custom component

The next sections introduce these capabilities one by one.

Using React state as the source of truth

(recommended for most React apps)

In real applications events usually come from the React state. Below is a complete example where Scheduler sends changes back to React via the data.save callback.

import { useState } from 'react';
import ReactScheduler, { Event } from '@dhtmlx/trial-react-scheduler';
import '@dhtmlx/trial-react-scheduler/dist/react-scheduler.css';
import { events as initialEvents } from './demoData';

export default function App() {
const [events, setEvents] = useState<Event[]>(initialEvents);

const data = {
save: (entity, action, item, id) => {
if (entity === 'event') {
if (action === 'create') setEvents((prev) => [...prev, item]);
if (action === 'update') setEvents((prev) => prev.map((x) => (x.id === id ? item : x)));
if (action === 'delete') setEvents((prev) => prev.filter((x) => x.id !== id));
}
},
};

return (
<div style={{ height: '100vh', width: '100vw' }}>
<ReactScheduler
events={events}
data={data}
// ...other props
/>
</div>
);
}

Why choose this mode

  • React always sees the same data as the Scheduler UI
  • Works perfectly with Redux / Zustand / Jotai / MobX
  • Easy to sync with backend APIs

Alternative Mode: Scheduler as the source of truth

(useful for very large datasets)

In this mode React does not own events.

<ReactScheduler
data={{
load: '/api/data', // scheduler loads initial events from here
save: '/api/data', // scheduler sends updates back here
}}
/>

When to prefer this mode

  • Tens of thousands of events
  • Frequent user interactions and updates
  • You want minimal React rendering overhead

Using Templates

(return React elements from template functions)

Templates allow customizing almost every part of the scheduler.

import ReactScheduler, { SchedulerTemplates } from '@dhtmlx/trial-react-scheduler';
import { useMemo } from 'react';
import EventTextBox from './components/EventTextBox';

const templates: SchedulerTemplates = useMemo(
() => ({
event_class: (start, end, event) => {
return 'templates-' + event.classname || '';
},
event_text: (start, end, event) => {
return <EventTextBox event={event} />;
},
}),
[]
);

<ReactScheduler templates={templates} />;

More details

See the full section here: React Scheduler Templates Documentation.

GitHub demo repository

A complete working project that follows this tutorial is provided on GitHub.

Next steps

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Quick Start with Vue Scheduler
This tutorial covers the Vue wrapper included in the Commercial, Enterprise, and Ultimate editions of DHTMLX Scheduler. If you are using the Individual or GPL edition, follow the alternative guide: How to Start with Vue.
The Vue Scheduler component is the official wrapper for DHTMLX Scheduler. This guide walks you through creating a small Vue 3 + Vite application and rendering a basic Scheduler using the trial package.
If you're new to Vue, start with the official Vue documentation.
Check a complete working project that follows this tutorial on GitHub.
Prerequisites
- Node.js installed
- npm or Yarn
- Vue 3 project (this page shows how to create one with Vite)
- Vue Scheduler package access (evaluation or professional)
1. Create A Vue 3 Project
Create a project with the official Vue scaffolding tool:
npm create vite@latest vue-scheduler-quick-start -- --template vue-ts
cd vue-scheduler-quick-start
npm install
If you prefer Yarn, replace the install step with yarn.
2. Install Vue Scheduler
Install Vue Scheduler as described in the Vue Scheduler installation guide.
In this tutorial we use the evaluation package:
For evaluation:
npm install @dhtmlx/trial-vue-scheduler
or
yarn add @dhtmlx/trial-vue-scheduler
The examples below use the evaluation package. If you installed the professional package, replace imports with @dhx/vue-scheduler.
3. Add Demo Data
Create src/demoData.ts:
import type { Event } from "@dhtmlx/trial-vue-scheduler";
export const mainDate = new Date("2026-08-15T00:00:00Z");
export const schedulerEvents: Event[] = [
{ id: 1, start_date: new Date("2026-08-10T02:00:00Z"), end_date: new Date("2026-08-10T10:20:00Z"), text: "Product Strategy Hike" },
{ id: 2, start_date: new Date("2026-08-10T12:00:00Z"), end_date: new Date("2026-08-10T16:00:00Z"), text: "Agile Meditation and Release" },
{ id: 3, start_date: new Date("2026-08-11T06:00:00Z"), end_date: new Date("2026-08-11T11:00:00Z"), text: "Tranquil Tea Time" },
{ id: 4, start_date: new Date("2026-08-11T11:30:00Z"), end_date: new Date("2026-08-11T19:00:00Z"), text: "Sprint Review and Retreat" },
{ id: 5, start_date: new Date("2026-08-12T01:00:00Z"), end_date: new Date("2026-08-12T03:00:00Z"), text: "Kayaking Workshop" },
{ id: 6, start_date: new Date("2026-08-12T06:00:00Z"), end_date: new Date("2026-08-12T08:00:00Z"), text: "Stakeholder Sunset Yoga Session" },
{ id: 7, start_date: new Date("2026-08-12T07:00:00Z"), end_date: new Date("2026-08-12T12:00:00Z"), text: "Roadmap Alignment Walk" },
{ id: 8, start_date: new Date("2026-08-12T13:00:00Z"), end_date: new Date("2026-08-12T18:00:00Z"), text: "Mindful Team Building" },
{ id: 9, start_date: new Date("2026-08-13T01:00:00Z"), end_date: new Date("2026-08-13T18:00:00Z"), text: "Cross-Functional Expedition" },
{ id: 10, start_date: new Date("2026-08-13T14:00:00Z"), end_date: new Date("2026-08-13T20:00:00Z"), text: "User Feedback Picnic" },
{ id: 11, start_date: new Date("2026-08-14T03:00:00Z"), end_date: new Date("2026-08-14T08:00:00Z"), text: "Demo and Showcase" },
{ id: 12, start_date: new Date("2026-08-14T11:00:00Z"), end_date: new Date("2026-08-14T17:00:00Z"), text: "Quality Assurance Spa Day" },
{ id: 13, start_date: new Date("2026-08-15T01:00:00Z"), end_date: new Date("2026-08-15T03:00:00Z"), text: "Motion Cycling Adventure" },
{ id: 14, start_date: new Date("2026-08-15T10:00:00Z"), end_date: new Date("2026-08-15T16:00:00Z"), text: "Competitor Analysis Beach Day" },
{ id: 15, start_date: new Date("2026-08-16T02:00:00Z"), end_date: new Date("2026-08-16T06:00:00Z"), text: "Creativity Painting Retreat" },
];
4. Create A Scheduler Component
Create src/components/Scheduler.vue:
<script setup lang="ts">
import { ref } from "vue";
import {
VueScheduler,
type Event,
type SchedulerConfig,
type VueSchedulerDataConfig,
} from "@dhtmlx/trial-vue-scheduler";
import "@dhtmlx/trial-vue-scheduler/dist/vue-scheduler.css";
import { mainDate, schedulerEvents } from "../demoData";
const events = ref<Event[]>(schedulerEvents);
const config: SchedulerConfig = {
first_hour: 6,
last_hour: 22,
};
const data: VueSchedulerDataConfig = {
save: (entity, action, item, id) => {
console.log("[data.save]", entity, action, item, id);
},
};
</script>
<template>
<div :style="{ height: '100vh', width: '100vw' }">
<VueScheduler :events="events" :date="mainDate" view="week" :config="config" :data="data" />
</div>
</template>
If you use the professional package, replace both imports:
@dhtmlx/trial-vue-scheduler->@dhx/vue-scheduler@dhtmlx/trial-vue-scheduler/dist/vue-scheduler.css->@dhx/vue-scheduler/dist/vue-scheduler.css
5. Render Scheduler In The App Shell
Replace the default content in src/App.vue:
<script setup lang="ts">
import Scheduler from "./components/Scheduler.vue";
</script>
<template>
<Scheduler />
</template>
6. Start The App
Run the dev server:
npm run dev
Open the local URL printed by Vite. You should see Scheduler rendered in week view with the demo events.
7. (Optional) Replace Logging With Local Save Handling
Use this when you want Vue state to stay in sync with scheduler edits before adding a backend or store. Update src/components/Scheduler.vue.
const data: VueSchedulerDataConfig = {
save: (entity, action, item, id) => {
if (entity !== "event") return;
if (action === "create") {
events.value = [...events.value, item as Event];
return;
}
if (action === "update") {
events.value = events.value.map(event => (event.id === id ? { ...(item as Event) } : event));
return;
}
if (action === "delete") {
events.value = events.value.filter(event => event.id !== id);
}
}
};
Result
You now have a Vue 3 app rendering the official Vue Scheduler wrapper with:
- reactive
eventsprops data.savecallback wiring for user edits
GitHub demo repository
A complete working project that follows this tutorial is provided on GitHub.

본문으로 건너뛰기

Quick Start with Angular Scheduler

노트

This tutorial covers the Angular wrapper included in the Commercial, Enterprise, and Ultimate editions of DHTMLX Scheduler. If you are using the Individual or GPL edition, follow the alternative guide: How to Start with Angular.

This guide renders a working Angular Scheduler in a standalone Angular application. It creates Scheduler inside a dedicated Angular component and mounts that component in the app shell.

Check a complete working project that follows this tutorial on GitHub.

1. Create An Angular Project

Create a standalone Angular app (Angular CLI):

ng new angular-scheduler-quick-start --standalone --routing=false --style=css
cd angular-scheduler-quick-start

If Angular CLI is not installed yet, install it first (npm install -g @angular/cli).

2. Install Angular Scheduler

Install Angular Scheduler as described in the installation guide.

In this tutorial we use the evaluation package:

npm install @dhtmlx/trial-angular-scheduler

or

yarn add @dhtmlx/trial-angular-scheduler

If you already use the Professional package, replace @dhtmlx/trial-angular-scheduler with @dhx/angular-scheduler in the commands and imports.

3. Add Global Styles

Open src/styles.css and add the Scheduler styles:

src/styles.css
@import "@dhtmlx/trial-angular-scheduler/dist/angular-scheduler.css";

html,
body {
height: 100%;
margin: 0;
}

app-root {
display: block;
height: 100vh;
}

This quick start uses a global CSS import, so you do not need ViewEncapsulation.None in the Scheduler component.

If you later move the Scheduler CSS import or overrides for internal Scheduler classes into a component stylesheet, Angular's default style encapsulation may scope those selectors. In that case, set encapsulation: ViewEncapsulation.None on that component, or keep the styles global.

4. Add Demo Data

Create src/app/demo-data.ts:

src/app/demo-data.ts
import type { Event } from "@dhtmlx/trial-angular-scheduler";

export const mainDate = new Date("2026-08-15T00:00:00Z");

export const schedulerEvents: Event[] = [
{ id: 1, start_date: new Date("2026-08-10T02:00:00Z"), end_date: new Date("2026-08-10T10:20:00Z"), text: "Product Strategy Hike" },
{ id: 2, start_date: new Date("2026-08-10T12:00:00Z"), end_date: new Date("2026-08-10T16:00:00Z"), text: "Agile Meditation and Release" },
{ id: 3, start_date: new Date("2026-08-11T06:00:00Z"), end_date: new Date("2026-08-11T11:00:00Z"), text: "Tranquil Tea Time" },
{ id: 4, start_date: new Date("2026-08-11T11:30:00Z"), end_date: new Date("2026-08-11T19:00:00Z"), text: "Sprint Review and Retreat" },
{ id: 5, start_date: new Date("2026-08-12T01:00:00Z"), end_date: new Date("2026-08-12T03:00:00Z"), text: "Kayaking Workshop" },
{ id: 6, start_date: new Date("2026-08-12T06:00:00Z"), end_date: new Date("2026-08-12T08:00:00Z"), text: "Stakeholder Sunset Yoga Session" },
{ id: 7, start_date: new Date("2026-08-12T07:00:00Z"), end_date: new Date("2026-08-12T12:00:00Z"), text: "Roadmap Alignment Walk" },
{ id: 8, start_date: new Date("2026-08-12T13:00:00Z"), end_date: new Date("2026-08-12T18:00:00Z"), text: "Mindful Team Building" },
{ id: 9, start_date: new Date("2026-08-13T01:00:00Z"), end_date: new Date("2026-08-13T18:00:00Z"), text: "Cross-Functional Expedition" },
{ id: 10, start_date: new Date("2026-08-13T14:00:00Z"), end_date: new Date("2026-08-13T20:00:00Z"), text: "User Feedback Picnic" },
{ id: 11, start_date: new Date("2026-08-14T03:00:00Z"), end_date: new Date("2026-08-14T08:00:00Z"), text: "Demo and Showcase" },
{ id: 12, start_date: new Date("2026-08-14T11:00:00Z"), end_date: new Date("2026-08-14T17:00:00Z"), text: "Quality Assurance Spa Day" },
{ id: 13, start_date: new Date("2026-08-15T01:00:00Z"), end_date: new Date("2026-08-15T03:00:00Z"), text: "Motion Cycling Adventure" },
{ id: 14, start_date: new Date("2026-08-15T10:00:00Z"), end_date: new Date("2026-08-15T16:00:00Z"), text: "Competitor Analysis Beach Day" },
{ id: 15, start_date: new Date("2026-08-16T02:00:00Z"), end_date: new Date("2026-08-16T06:00:00Z"), text: "Creativity Painting Retreat" },
];

5. Create A Scheduler Component

Create src/app/scheduler.component.ts:

src/app/scheduler.component.ts
import { Component } from "@angular/core";
import {
DhxSchedulerComponent,
type AngularSchedulerDataConfig,
type Event,
type SchedulerConfig,
} from "@dhtmlx/trial-angular-scheduler";
import { mainDate, schedulerEvents } from "./demo-data";

@Component({
selector: "app-scheduler",
standalone: true,
imports: [DhxSchedulerComponent],
host: { style: "display:block;height:100%;" },
template: `
<dhx-scheduler
[events]="events"
[date]="date"
[config]="config"
[data]="dataConfig"
view="week">
</dhx-scheduler>
`,
})
export class SchedulerComponent {
events: Event[] = schedulerEvents;
date = mainDate;

config: SchedulerConfig = {
first_hour: 6,
last_hour: 22,
};

dataConfig: AngularSchedulerDataConfig = {
save: (entity, action, data, id) => {
console.log("[data.save]", entity, action, data, id);
},
};
}

6. Render Scheduler In The App Shell

Replace src/app/app.ts:

src/app/app.ts
import { Component } from "@angular/core";
import { SchedulerComponent } from "./scheduler.component";

@Component({
selector: "app-root",
standalone: true,
imports: [SchedulerComponent],
template: `<app-scheduler></app-scheduler>`,
})
export class App {}

If your Angular project uses app.component.ts instead of app.ts, apply the same component code there and keep the class name expected by your main.ts.

7. Start The App

ng serve

Open http://localhost:4200. You should see Scheduler rendered in week view with the demo events. Edits will be logged through data.save.

If you are adding Scheduler to an existing app, keep your current app shell and place <app-scheduler> in the target page or route component. Make sure the parent layout provides a height to the Scheduler area.

Optional: Minimal Local Save Handling

As a next step, replace logging with local array synchronization:

src/app/scheduler.component.ts
dataConfig: AngularSchedulerDataConfig = {
save: (entity, action, item, id) => {
if (entity !== "event") return;

if (action === "create") {
this.events = [...this.events, item as Event];
return;
}

if (action === "update") {
this.events = this.events.map(event =>
String(event.id) === String(id) ? { ...(item as Event) } : event
);
return;
}

if (action === "delete") {
this.events = this.events.filter(event => String(event.id) !== String(id));
}
},
};

For grouped updates, prefer data.batchSave and handle all changes in one state transaction.

GitHub demo repository

A complete working project that follows this tutorial is provided on GitHub.

Continue With

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.